#pragma once

#include <Arduino.h>
#include <ArduinoJson.h>
#include <HTTPClient.h>
#include <memory>
#include <string>
#include <map>

#include "lib/screen_handler.hpp"

class LNBitsFetch {
private:
    LNBitsFetch();
    static LNBitsFetch* instance;
    
    bool initialized;
    TaskHandle_t taskHandle;
    std::map<std::string, uint> priceMap;
    std::map<std::string, unsigned long int> lastUpdateMap;
    std::string currentCurrency;
    String buildApiUrl(const std::string& currency);
    
public:
    static LNBitsFetch& getInstance();
    
    void setup();
    void fetchRates();
    void stop();
    void restart();
    void setCurrentCurrency(const std::string& currency);
    std::string getCurrentCurrency() const;
    
    bool isInitialized() const;
    TaskHandle_t getTaskHandle() const;
    
    uint getPrice(const std::string& currencyCode);
    void setPrice(uint newPrice, const std::string& currencyCode);
    unsigned long int getLastPriceUpdate(const std::string& currencyCode);
};

void setupLnbits();
void taskLNBits(void* pvParameters); 